VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsPopUpTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit
'-----------------------------------------
'Autor:     Leandro Ascierto
'Web:       www.leandroascierto.com
'Date       14/06/2011
'-----------------------------------------
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function GetTickCount Lib "kernel32.dll" () As Long
Private Declare Function WaitMessage Lib "user32.dll" () As Long
Private Declare Function SetWindowLongA Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProcA Lib "user32" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetParent Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function SHAppBarMessage Lib "shell32.dll" (ByVal dwMessage As Long, pData As APPBARDATA) As Long
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetForegroundWindow Lib "user32.dll" () As Long
Private Declare Function GetClientRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function IsWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function ShowWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal Hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal Hdc As Long) As Long
Private Declare Function GetAncestor Lib "user32.dll" (ByVal hwnd As Long, ByVal gaFlags As Long) As Long

Private Type POINTAPI
    x           As Long
    y           As Long
End Type

Private Type RECT
    Left        As Long
    Top         As Long
    Right       As Long
    Bottom      As Long
End Type

Private Enum TASKPOS
    ABE_LEFT = 0
    ABE_TOP = 1
    ABE_RIGHT = 2
    ABE_BOTTOM = 3
End Enum

Private Type APPBARDATA
    cbSize              As Long
    hwnd                As Long
    uCallbackMessage    As Long
    uEdge               As TASKPOS
    rc                  As RECT
    lParam              As Long
End Type

Private Const SWP_NOMOVE        As Long = &H2
Private Const HWND_TOPMOST      As Long = -1
Private Const SWP_NOSIZE        As Long = &H1
Private Const SWP_SHOWWINDOW    As Long = &H40
Private Const SWP_FRAMECHANGED  As Long = &H20
Private Const SWP_HIDEWINDOW As Long = &H80
Private Const SWP_NOACTIVATE As Long = &H10


Private Const WM_DESTROY        As Long = &H2
Private Const WM_NCHITTEST      As Long = &H84
Private Const WM_KILLFOCUS      As Long = &H8
Private Const WM_USER           As Long = &H400
Private Const WM_SIZE As Long = &H5

Private Const TB_GETBUTTONSIZE  As Long = (WM_USER + 58)

Private Const GWL_WNDPROC       As Long = -4
Private Const GWL_STYLE         As Long = -16
Private Const GWL_EXSTYLE       As Long = -20

Private Const WS_THICKFRAME     As Long = &H40000
Private Const WS_BORDER         As Long = &H800000
Private Const WS_EX_WINDOWEDGE  As Long = &H100&

Private Const ABM_GETTASKBARPOS As Long = &H5

Private TimeLast    As Long
Private hToolBar    As Long
Private PT          As POINTAPI
Private PrevWndProc As Long
Private bvASM(40)   As Byte
Private m_hwnd      As Long
 
Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    Select Case uMsg
    
        Case WM_DESTROY
            Call StopSubclassing(hwnd)
            
        Case WM_NCHITTEST
            WindowProc = 1
            Exit Function
            
        Case WM_KILLFOCUS
            Call StopSubclassing(hwnd)
            'DestroyWindow hwnd
            ShowWindow hwnd, 0
            
        Case WM_SIZE
            LocateWindow hwnd
            
    End Select
    
    WindowProc = CallWindowProcA(PrevWndProc, hwnd, uMsg, wParam, lParam)

    
    
End Function

Private Sub SetSubclassing(Obj As Object, hwnd As Long)
    Dim WindowProcAddress As Long
    Dim pObj As Long
    Dim pVar As Long
 
    Dim i As Long
 
    For i = 0 To 40
        bvASM(i) = Choose(i + 1, &H55, &H8B, &HEC, &H83, &HC4, &HFC, &H8D, &H45, &HFC, &H50, &HFF, &H75, &H14, _
                                 &HFF, &H75, &H10, &HFF, &H75, &HC, &HFF, &H75, &H8, &H68, &H0, &H0, &H0, &H0, _
                                 &HB8, &H0, &H0, &H0, &H0, &HFF, &HD0, &H8B, &H45, &HFC, &HC9, &HC2, &H10, &H0)
    Next i
 
    pObj = ObjPtr(Obj)
 
    Call CopyMemory(pVar, ByVal pObj, 4)
    Call CopyMemory(WindowProcAddress, ByVal (pVar + 28), 4)
 
    Call LongToByte(pObj, bvASM, 23)
    Call LongToByte(WindowProcAddress, bvASM, 28)
 
    PrevWndProc = SetWindowLongA(hwnd, GWL_WNDPROC, VarPtr(bvASM(0)))
End Sub
 
Private Sub StopSubclassing(hwnd)
    If PrevWndProc Then
        Call SetWindowLongA(hwnd, GWL_WNDPROC, PrevWndProc)
        PrevWndProc = 0
    End If
End Sub
 
Private Sub LongToByte(ByVal lLong As Long, ByRef bReturn() As Byte, Optional i As Integer = 0)
    bReturn(i) = lLong And &HFF
    bReturn(i + 1) = (lLong And 65280) / &H100
    bReturn(i + 2) = (lLong And &HFF0000) / &H10000
    bReturn(i + 3) = ((lLong And &HFF000000) \ &H1000000) And &HFF
End Sub

Private Function ClassName(ByVal hwnd As Long) As String
    Dim lpClassName As String * 256
    Dim RetVal As Long
    RetVal = GetClassName(hwnd, lpClassName, 256)
    ClassName = Left$(lpClassName, RetVal)
End Function

Public Sub Cancel()
    If IsWindow(m_hwnd) Then DestroyWindow m_hwnd
End Sub

Public Sub ShowPopUp(ByVal hwnd As Long)
    Dim ClientRec As RECT
    Dim MeRect As RECT
    Dim lDiff As Long
   
    
    If TimeLast + 500 > GetTickCount Then
        'DestroyWindow hwnd
        Call StopSubclassing(hwnd)
        ShowWindow hwnd, 0
        Exit Sub
    End If
    
    m_hwnd = hwnd
    
    TimeLast = Time
    
    GetClientRect hwnd, ClientRec
    GetWindowRect hwnd, MeRect
    lDiff = ClientRec.Bottom

    SetWindowLongA hwnd, GWL_STYLE, WS_THICKFRAME Or WS_BORDER
    SetWindowLongA hwnd, GWL_EXSTYLE, WS_EX_WINDOWEDGE
    SetWindowPos hwnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_FRAMECHANGED Or SWP_NOACTIVATE

    GetClientRect hwnd, ClientRec
    lDiff = lDiff - ClientRec.Bottom
    
    SetWindowPos hwnd, 0, 0, 0, MeRect.Right - MeRect.Left, (MeRect.Bottom - MeRect.Top) + lDiff, SWP_NOMOVE Or SWP_FRAMECHANGED Or SWP_NOACTIVATE

    GetCursorPos PT
    hToolBar = WindowFromPoint(PT.x, PT.y)
    
    Call LocateWindow(hwnd)

    SetForegroundWindow hwnd
    SetSubclassing Me, hwnd
    Do While GetForegroundWindow = hwnd
        DoEvents
        WaitMessage
    Loop
        
    TimeLast = GetTickCount
    
    'DestroyWindow hwnd
    ShowWindow hwnd, 0
    Call StopSubclassing(hwnd)
End Sub

Private Sub LocateWindow(ByVal hwnd As Long)
    Dim x           As Long
    Dim y           As Long
    Dim lRet        As Long
    Dim BtnTop      As Long
    Dim BtnLeft     As Long
    Dim BtnWidth    As Long
    Dim BtnHeight   As Long
    Dim MeRect      As RECT
    Dim ToolBarRect As RECT
    Dim MeWidth     As Long
    Dim MeHeight    As Long
    Dim ABD         As APPBARDATA
    Dim ShadowSize  As Long
    Dim DPI_ZOOM    As Double
    
    
    
    ShadowSize = 10
    
     
    DPI_ZOOM = ScreenZoom
  
    GetWindowRect hToolBar, ToolBarRect
    GetWindowRect hwnd, MeRect

    ABD.cbSize = Len(ABD)
    SHAppBarMessage ABM_GETTASKBARPOS, ABD
    
    
    lRet = SendMessage(hToolBar, TB_GETBUTTONSIZE, 0&, 0&)
    
    If lRet Then
        BtnWidth = lRet And &HFFFF& 'LoWord
        BtnHeight = lRet \ &H10000 And &HFFFF& 'HiWord
        BtnWidth = BtnWidth / DPI_ZOOM
        BtnHeight = BtnHeight / DPI_ZOOM
        BtnTop = (BtnHeight * ((PT.y - ToolBarRect.Top) \ BtnHeight))
        BtnLeft = (BtnWidth * ((PT.x - ToolBarRect.Left) \ BtnWidth))
    End If

    MeWidth = (MeRect.Right - MeRect.Left)
    MeHeight = (MeRect.Bottom - MeRect.Top)

    Select Case True
        Case ABD.uEdge = ABE_BOTTOM
            x = ToolBarRect.Left + BtnLeft + (BtnWidth / 2) - (MeWidth / 2)
            If ClassName(GetParent(hToolBar)) = "SysPager" Then

                y = ABD.rc.Top / DPI_ZOOM - MeHeight - ShadowSize
            Else
                y = ToolBarRect.Top + BtnTop - MeHeight - ShadowSize
            End If
            
        Case ABD.uEdge = ABE_RIGHT
            
            If ClassName(GetParent(hToolBar)) = "SysPager" Then
                GetWindowRect GetAncestor(hToolBar, 3), ABD.rc 'DPI Fix
                x = ABD.rc.Left - MeWidth - ShadowSize
                y = ToolBarRect.Top + BtnTop - (MeHeight / 2)
            Else
                x = ToolBarRect.Left + BtnLeft + (BtnWidth / 2) - (MeWidth / 2)
                y = ToolBarRect.Top + BtnTop - MeHeight - ShadowSize
            End If
            
            'If x + MeWidth + ShadowSize > (ABD.rc.Left / DPI_ZOOM) Then x = (ABD.rc.Left / DPI_ZOOM) - MeWidth - ShadowSize
            
        Case ABD.uEdge = ABE_TOP
            x = ToolBarRect.Left + BtnLeft + (BtnWidth / 2) - (MeWidth / 2)
            If ClassName(GetParent(hToolBar)) = "SysPager" Then
                y = (ABD.rc.Bottom / DPI_ZOOM) + ShadowSize
            Else
                y = ToolBarRect.Top + BtnTop + BtnHeight + ShadowSize
            End If
            
        Case ABD.uEdge = ABE_LEFT
            If ClassName(GetParent(hToolBar)) = "SysPager" Then
                x = (ABD.rc.Right / DPI_ZOOM) + ShadowSize
                y = ToolBarRect.Top + BtnTop + (BtnHeight / 2) - (MeHeight / 2)
            Else
                x = ToolBarRect.Left + BtnLeft + (BtnWidth / 2) - (MeWidth / 2)
                y = ToolBarRect.Top + BtnTop - MeHeight - ShadowSize
            End If
            
           ' If x < (ABD.rc.Right / DPI_ZOOM) Then x = (ABD.rc.Right / DPI_ZOOM) + ShadowSize
    End Select
    
    
    If x + MeWidth + ShadowSize > Screen.Width / Screen.TwipsPerPixelX Then x = Screen.Width / Screen.TwipsPerPixelX - MeWidth - ShadowSize
    If y < 0 Then y = ToolBarRect.Bottom
    If y + MeHeight + ShadowSize > Screen.Height / Screen.TwipsPerPixelY Then y = Screen.Height / Screen.TwipsPerPixelY - MeHeight - ShadowSize

    SetWindowPos hwnd, HWND_TOPMOST, x, y, 0, 0, SWP_SHOWWINDOW Or SWP_NOSIZE Or SWP_FRAMECHANGED

End Sub


Public Property Get ScreenZoom() As Single
    Dim Hdc As Long
    Hdc = GetDC(0)
    ScreenZoom = GetDeviceCaps(Hdc, 118) / (Screen.Width / Screen.TwipsPerPixelX)
    ReleaseDC 0&, Hdc
End Property


